<?php
/*
Plugin Name: GetSocial
Plugin URI: http://www.riyaz.net/getsocial
Description: GetSocial adds an intelligent, lightweight, quick to setup floating social media sharing box on your blog posts.
Author: Riyaz
Version: 1.3.1
Author URI: http://www.riyaz.net
License: GPL2
*/

/*  Copyright 2010  Riyaz Sayyad  (email : riyaz@riyaz.net)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/* ----------------------------------------------
** Feature Credits **
Name: Custom Write Panel 
URI: http://wefunction.com/2008/10/tutorial-create-custom-write-panels-in-wordpress 
Description: Allows custom fields to be added to the WordPress Post Page 
Version: 1.0 
Author: Spencer 
Author URI: http://wefunction.com 
----------------------------------------------*/  
?>
<?php
//enable the jQuery library in Wordpress
function getsocial_init() {
if ( !is_admin() ) {
 wp_enqueue_script('jquery');
 }
}
add_action('init', 'getsocial_init');
?>
<?php
function add_getsocial_styles(){
if (showbox()){
?>
<link rel="stylesheet" type="text/css" href="<?php echo WP_PLUGIN_URL . '/getsocial/lib/getsocial.css'; ?>" />
<?php
}
}
add_action('wp_head','add_getsocial_styles');
?>
<?php
function get_getsocial_scripts(){
$getsocial_js = "";
if (showbox()){
	$getsocial_js = '<script type="text/javascript">'
					.'var $opt_initial_top = '. get_option('getsocial_initial_top') .';'
					.'var $opt_scrolled_top = '. get_option('getsocial_scrolled_top') .';'
					.'var $opt_browser_width = '. get_option('getsocial_browser_width') .';'
					.'var $opt_box_left = '. get_option('getsocial_left') .';'
					.'</script>'
					.'<script type="text/javascript" src="'. WP_PLUGIN_URL . '/getsocial/lib/getsocial.js'.'"></script>';
	}
	return $getsocial_js;
}
?>
<?php
function add_getsocial_div($content) {
global $post;
global $gs_url;
$gs_url = get_permalink($post->ID);
	if (showbox()){ $content = '<div id="getsocialmain">' . $content . '</div><!-- #getsocialmain -->'; }
	return $content;
}
?>
<?php
function add_getsocial_scripts(){ echo get_getsocial_scripts();}
function add_getsocial_box(){ echo get_getsocial_box();}
if (get_option('getsocial_scripts_in_footer') == "true") {
	add_filter('the_content', 'add_getsocial_div', 30);
	add_action('wp_footer','add_getsocial_scripts');
	add_action('wp_footer','add_getsocial_box');
}
else{
	add_action('wp_head','add_getsocial_scripts');
	add_action('wp_head','add_getsocial_box');
	add_filter('the_content', 'add_getsocial_div', 30);
}
?>
<?php
function showbox(){
global $post;  
$hide_box_value = get_post_meta($post->ID, 'getsocial_hide_value', true);  
if (is_single() && get_option('getsocial_show_on_posts') == "true" && $hide_box_value != "true" ) return true;
if (is_page() && get_option('getsocial_show_on_pages') == "true" && $hide_box_value != "true" ) return true;
return false;
}
?>
<?php
function get_getsocial_box(){
$getsocial_html = "";
/*global $post;*/
/*$permalink = get_permalink($post->ID);*/
global $gs_url;
$permalink = $gs_url;
if (showbox()){
	?>
	<?php $getsocial_html = '<div class="getsocial">'; ?>
	<?php if (get_option('getsocial_twitter') == "true") {
	$getsocial_html .= '<div class="sharebutton">'
					.'<a href="http://twitter.com/share" class="twitter-share-button" data-count="vertical" data-via="'. get_option('getsocial_twitter_username') .'" data-related="'. get_option('getsocial_twitter_username') .'">Tweet</a>'
					.'<script type="text/javascript" src="http://platform.twitter.com/widgets.js"></script></div>';
	} ?>
	<?php if (get_option('getsocial_tweetmeme') == "true") {
	$getsocial_html .= '<div class="sharebutton">'
					.'<script type="text/javascript">tweetmeme_source = \''. get_option('getsocial_twitter_username') .'\'; tweetmeme_service = \'bit.ly\'; tweetmeme_url = \''. $permalink .'\'</script>'
					.'<script type="text/javascript" src="http://tweetmeme.com/i/scripts/button.js"></script></div>';
	} ?>
	<?php if (get_option('getsocial_facebook') == "true") {
	$getsocial_html .= '<div class="sharebutton">'
					.'<a name="fb_share" type="box_count" share_url="'. $permalink  .'"></a>'
					.'<script src="http://static.ak.fbcdn.net/connect.php/js/FB.Share" type="text/javascript"></script></div>';
	} ?>
	<?php if (get_option('getsocial_googlebuzz') == "true") {
	$getsocial_html .= '<div class="sharebutton">'
					.'<a title="Post on Google Buzz" class="google-buzz-button" href="http://www.google.com/buzz/post" data-button-style="normal-count" data-locale="en_IN"></a>'
					.'<script type="text/javascript" src="http://www.google.com/buzz/api/button.js"></script></div>';
	} ?>
	<?php if (get_option('getsocial_stumbleupon') == "true") {
	$getsocial_html .= '<div class="sharebutton"><script src="http://www.stumbleupon.com/hostedbadge.php?s=5"></script></div>';
	} ?>
	<?php if (get_option('getsocial_digg') == "true") {
	$getsocial_html .= '<div class="sharebutton">'
					.'<script type="text/javascript">'
					.'(function() {'
					.'var s = document.createElement(\'SCRIPT\'), s1 = document.getElementsByTagName(\'SCRIPT\')[0];'
					.'s.type = \'text/javascript\';'
					.'s.async = true;'
					.'s.src = \'http://widgets.digg.com/buttons.js\';'
					.'s1.parentNode.insertBefore(s, s1);'
					.'})();'
					.'</script>'
					.'<a class="DiggThisButton DiggMedium"></a></div>';
	} ?>
	<?php if (get_option('getsocial_blendit') == "true") {
	$getsocial_html .= '<div class="sharebutton">'
					.'<script type="text/javascript">url_site=\''. $permalink .'\';</script>'
					.'<script src="http://thewebblend.com/sites/all/modules/drigg_external/js/button.js" type="text/javascript"></script></div>';
	} ?>
	<?php 
	$getsocial_additional = get_option('getsocial_additional');
	if ( $getsocial_additional != "") {
	$getsocial_html .= '<div class="sharebutton">' . $getsocial_additional .'</div>';
	} ?>
	<?php if (get_option('getsocial_linkluv') == "true") {
	$getsocial_html .= '<div class="sharebutton sharefooter"><a href="http://www.riyaz.net/getsocial" title="GetSocial Plugin by riyaz.net">GetSocial</a></div>';
	} ?>
	<?php $getsocial_html .= '</div>'; ?>
	<?php
	}
	return $getsocial_html;
}
?>
<?php
// create custom plugin settings menu
add_action('admin_menu', 'getsocial_create_menu');

function getsocial_create_menu() {
	//create new top-level menu
	add_menu_page('GetSocial Settings', 'GetSocial', 'administrator', __FILE__, 'getsocial_settings_page',plugins_url('/images/riyaznet.ico', __FILE__));

	//call register settings function
	add_action( 'admin_init', 'register_getsocial_settings' );
}

function register_getsocial_settings() {
	//register the settings
	register_setting( 'getsocial-settings-group', 'getsocial_initial_top', 'intval' );
	register_setting( 'getsocial-settings-group', 'getsocial_scrolled_top' , 'intval' );
	register_setting( 'getsocial-settings-group', 'getsocial_left' , 'intval' );
	register_setting( 'getsocial-settings-group', 'getsocial_browser_width' , 'intval' );
	register_setting( 'getsocial-settings-group', 'getsocial_show_on_posts' );
	register_setting( 'getsocial-settings-group', 'getsocial_show_on_pages' );
	register_setting( 'getsocial-settings-group', 'getsocial_twitter' );
	register_setting( 'getsocial-settings-group', 'getsocial_tweetmeme' );
	register_setting( 'getsocial-settings-group', 'getsocial_twitter_username' );
	register_setting( 'getsocial-settings-group', 'getsocial_facebook' );
	register_setting( 'getsocial-settings-group', 'getsocial_googlebuzz' );
	register_setting( 'getsocial-settings-group', 'getsocial_stumbleupon' );
	register_setting( 'getsocial-settings-group', 'getsocial_digg' );
	register_setting( 'getsocial-settings-group', 'getsocial_blendit' );
	register_setting( 'getsocial-settings-group', 'getsocial_additional' );
	register_setting( 'getsocial-settings-group', 'getsocial_linkluv' );
	register_setting( 'getsocial-settings-group', 'getsocial_scripts_in_footer' );
}

function getsocial_settings_page() {
?>
<div class="wrap">
<h2>GetSocial Settings</h2>
<?php
global $wp_query;
if( $_GET['updated'] ) { ?>
	<div id="message" class="updated">Settings Saved Successfully.</div>
<?php } ?>

<h3>Positioning</h3>
<form method="post" action="options.php">
    <?php settings_fields( 'getsocial-settings-group' ); ?>
    <table class="form-table">
        <tr valign="top">
        <th scope="row">Initial Offset from top</th>
        <td><input type="text" name="getsocial_initial_top" value="<?php echo get_option('getsocial_initial_top', 200); ?>" style="width: 50px;" /> px<br>(Default: <strong>200px</strong>. Distance in pixels from the top of the window when the page is first loaded.)</td>
        </tr>
         
        <tr valign="top">
        <th scope="row">Offset from top after scrolling</th>
        <td><input type="text" name="getsocial_scrolled_top" value="<?php echo get_option('getsocial_scrolled_top', 20); ?>" style="width: 50px;"/>px,<br>(Default: <strong>20px</strong>. Distance in pixels from the top of the window after the user has scrolled down considerably.)</td></td>
        </tr>
        
        <tr valign="top">
        <th scope="row">Offset from left</th>
        <td><input type="text" name="getsocial_left" value="<?php echo get_option('getsocial_left', 80); ?>" style="width: 50px;"/> px<br>(Default: <strong>80px</strong>. Adjust this value to move the GetSocial box horizontally. Higher value moves it farther to the left, while lower value moves it to the right.)</td>
        </tr>
		
		<tr valign="top">
        <th scope="row">Browser Width</th>
        <td><input type="text" name="getsocial_browser_width" value="<?php echo get_option('getsocial_browser_width', 1140); ?>" style="width: 50px;"/> px<br>(Default: <strong>1140px</strong>. This is the minimum width of the browser window to allow full display of GetSocial box without hiding to the left. <br>When the browser window is resized to a value smaller than this, GetSocial box partially hides to the left. Hovering over it will allow full display. <br>This feature is also useful for users using screens with lower resolution like 800x600px. <br>Adjust this value according to the maximum width of your theme's used up area. For example, if your theme's used up width is 1000px, you may set the browser width to 1140px (1000 + 140) or slighly higher.)</td>
        </tr>
    </table>
<h3>Display Options</h3>
	<table class="form-table">
        <tr valign="top">
        <th scope="row">Display on Posts</th>
        <td><input type="checkbox" name="getsocial_show_on_posts" value="true" <?php if (get_option('getsocial_show_on_posts', true) == "true") { _e('checked="checked"', "getsocial_show_on_posts"); }?> /></td>
        </tr>
		
		<tr valign="top">
        <th scope="row">Display on Pages</th>
        <td><input type="checkbox" name="getsocial_show_on_pages" value="true" <?php if (get_option('getsocial_show_on_pages', false) == "true") { _e('checked="checked"', "getsocial_show_on_pages"); }?> /></td>
        </tr>
		
		<tr valign="top">
        <td colspan="2">(The display settings can be overridden on individual posts/pages by changing the GetSocial Settings on the Edit Page/Post screen.)</td>
        </tr>		
    </table>
<h3>Social Media Buttons</h3>
    <table class="form-table">
        <tr valign="top">
        <th scope="row">Twitter Tweet Button</th>
        <td><input type="checkbox" name="getsocial_twitter" value="true" <?php if (get_option('getsocial_twitter', true) == "true") { _e('checked="checked"', "getsocial_twitter"); }?> /> (Displays Tweet button from Twitter.)</td>
        </tr>
        
		<tr valign="top">
        <th scope="row">Tweetmeme Retweet Button</th>
        <td><input type="checkbox" name="getsocial_tweetmeme" value="true" <?php if (get_option('getsocial_tweetmeme', false) == "true") { _e('checked="checked"', "getsocial_tweetmeme"); }?> /> (Displays Retweet button from Tweetmeme.)</td>
        </tr>
         
		<tr valign="top">
        <th scope="row">Twitter Username</th>
        <td>
        <input type="text" name="getsocial_twitter_username" value="<?php echo get_option('getsocial_twitter_username'); ?>" /> (Specify the Twitter username to be used for retweeting.)</td>
        </tr>
        
        <tr valign="top">
        <th scope="row">Facebook Share Button</th>
        <td><input type="checkbox" name="getsocial_facebook" value="true" <?php if (get_option('getsocial_facebook', true) == "true") { _e('checked="checked"', "getsocial_facebook"); }?> /> (Displays Facebook Share button.)</td>
        </tr>
		
		<tr valign="top">
        <th scope="row">Google Buzz Button</th>
        <td><input type="checkbox" name="getsocial_googlebuzz" value="true" <?php if (get_option('getsocial_googlebuzz', true) == "true") { _e('checked="checked"', "getsocial_googlebuzz"); }?> /> (Displays Add to Google Buzz button.)</td>
        </tr>
		
		<tr valign="top">
        <th scope="row">StumbleUpon Button</th>
        <td><input type="checkbox" name="getsocial_stumbleupon" value="true" <?php if (get_option('getsocial_stumbleupon', false) == "true") { _e('checked="checked"', "getsocial_stumbleupon"); }?> /> (Displays StumbleUpon Submit button.)</td>
        </tr>
		
		<tr valign="top">
        <th scope="row">Digg Button</th>
        <td><input type="checkbox" name="getsocial_digg" value="true" <?php if (get_option('getsocial_digg', false) == "true") { _e('checked="checked"', "getsocial_digg"); }?> /> (Displays Submit to Digg button.)</td>
        </tr>
		
		<tr valign="top">
        <th scope="row">Blend Button</th>
        <td><input type="checkbox" name="getsocial_blendit" value="true" <?php if (get_option('getsocial_blendit', false) == "true") { _e('checked="checked"', "getsocial_blendit"); }?> /> (Displays Blend It button.)</td>
        </tr>
		
		<tr valign="top">
        <th scope="row">Additional buttons</th>
        <td>
			<textarea name="getsocial_additional" id="getsocial_additional" cols="60" rows="12">
			<?php echo stripslashes(htmlentities (get_option('getsocial_additional'))); ?></textarea></td>
			<td>To show additional buttons, simply add HTML code for the buttons here.
			<br>Enclose the code for each button within <code>&lt;div class="sharebutton"&gt;</code> and <code>&lt;/div&gt;</code> tags.<br>
			<br>For example:
			<br><code>&lt;div class="sharebutton"&gt;
			<br>&nbsp;&nbsp;&lt;!-- Code for additional button 1 --&gt;
			<br>&lt;/div&gt;
			<br>&lt;div class="sharebutton"&gt;
			<br>&nbsp;&nbsp;&lt;!-- Code for additional button 2 --&gt;
			<br>&lt;/div&gt;</code>
        </td>
        </tr>
		
		<tr valign="top">
        <th scope="row">Support us through Linkluv</th>
        <td><input type="checkbox" name="getsocial_linkluv" value="true" <?php if (get_option('getsocial_linkluv', true) == "true") { _e('checked="checked"', "getsocial_linkluv"); }?> /> (Shows a tiny unobtrusive link to GetSocial homepage. Thank you for your support.)</td>
        </tr>
    </table>
<h3>Advanced Options</h3>
	<table class="form-table">
        <tr valign="top">
        <th scope="row">Load scripts in Footer</th>
        <td><input type="checkbox" name="getsocial_scripts_in_footer" value="true" <?php if (get_option('getsocial_scripts_in_footer', true) == "true") { _e('checked="checked"', "getsocial_scripts_in_footer"); }?> /> (Loads scripts in footer by default. Uncheck this only if the GetSocial box does not appear at all.)</td>
        </tr>
    </table>
    
    <p class="submit">
    <input type="submit" class="button-primary" value="<?php _e('Save Changes') ?>" />
    </p>

</form>
<p>Thank you for using <a href="http://www.riyaz.net/getsocial" title="GetSocial Homepage" target="_blank">GetSocial</a>. | For Help and Support use <a href="http://www.riyaz.net/forums/forum.php?id=10" title="riyaz.net Forums" target="_blank">Forums</a> or Ask on <a href="http://twitter.com/riyaznet" title="@riyaznet" target="_blank">Twitter</a>.<br>For latest news and updates subscribe via <a href="http://feeds.riyaz.net/RiyaznetBlog" title="Subscribe to riyaz.net RSS feed" target="_blank">RSS</a> or <a href="http://feedburner.google.com/fb/a/mailverify?uri=RiyaznetBlog&loc=en_US" title="Get riyaz.net Newsletter by email" target="_blank">Email</a> | Follow us on <a href="http://twitter.com/riyaznet" title="Follow @riyaznet on Twitter" target="_blank">Twitter</a> | Become a fan on <a href="http://www.facebook.com/riyaznet" title="Like us on Facebook" target="_blank">Facebook</a>.</p>
</div>
<?php } ?>
<?php 
$getsocial_meta_boxes =  
array(  
"getsocial_hide" => array(  
"name" => "getsocial_hide",  
"std" => "",  
"title" => "Hide GetSocial box on this post/page",  
"description" => "Hide GetSocial box on this post/page")  
);  

function getsocial_meta_boxes() {  
	global $post, $getsocial_meta_boxes;  
	  
	foreach($getsocial_meta_boxes as $meta_box) {  
	$meta_box_value = get_post_meta($post->ID, $meta_box['name'].'_value', true);  
	  
	if($meta_box_value == "")  
	$meta_box_value = $meta_box['std'];  
	  
	echo'<input type="hidden" name="'.$meta_box['name'].'_noncename" id="'.$meta_box['name'].'_noncename" value="'.wp_create_nonce( plugin_basename(__FILE__) ).'" />';  
	  
	echo''.$meta_box['title'].' ';  

	if($meta_box_value == true)   
		echo'<input type="checkbox" name="'.$meta_box['name'].'_value" value="true" checked="checked" /><br />';  
	else
		echo'<input type="checkbox" name="'.$meta_box['name'].'_value" value="true" /><br />';  
	} 
}
function create_getsocial_meta_box() {  
global $theme_name;  
if ( function_exists('add_meta_box') ) {  
	add_meta_box( 'new-meta-boxes', 'GetSocial Settings', 'getsocial_meta_boxes', 'page', 'normal', 'high' );  
	add_meta_box( 'new-meta-boxes', 'GetSocial Settings', 'getsocial_meta_boxes', 'post', 'normal', 'high' );  
	}  
}  

function save_getsocial_postdata( $post_id ) {  
global $post, $getsocial_meta_boxes;  
  
foreach($getsocial_meta_boxes as $meta_box) {  
// Verify  
if ( !wp_verify_nonce( $_POST[$meta_box['name'].'_noncename'], plugin_basename(__FILE__) )) {  
return $post_id;  
}  
  
if ( 'page' == $_POST['post_type'] ) {  
if ( !current_user_can( 'edit_page', $post_id ))  
return $post_id;  
} else {  
if ( !current_user_can( 'edit_post', $post_id ))  
return $post_id;  
}  
  
$data = $_POST[$meta_box['name'].'_value'];  
  
if(get_post_meta($post_id, $meta_box['name'].'_value') == "")  
add_post_meta($post_id, $meta_box['name'].'_value', $data, true);  
elseif($data != get_post_meta($post_id, $meta_box['name'].'_value', true))  
update_post_meta($post_id, $meta_box['name'].'_value', $data);  
elseif($data == "")  
delete_post_meta($post_id, $meta_box['name'].'_value', get_post_meta($post_id, $meta_box['name'].'_value', true));  
}  
}  
add_action('admin_menu', 'create_getsocial_meta_box');  
add_action('save_post', 'save_getsocial_postdata');   
?>